/**
 * This class represents a Date Object
 * @author Galit Shriki & Ilan Perets
 * @version 10.6.2011
 */
public class Date 
{
  //attributes:
  private int day;
  private int month;
  private int year;
  
  
  //constructor:
  /**
   * creates a new Date object
   * @param day the day in the month(1-31) 
   * @param month the month in the year
   * @param year the year (in 4 digits)
   */
  public Date(int day, int month, int year)
  {
     this.day = day;
     this.month = month;
     this.year = year;
  }
  
//copy constructor:
  /**
   * creates a new Date object
   * @param date contains the day,month,year
   */
  public Date(Date date)
  {
     this.day = date.day;
     this.month = date.month;
     this.year = date.year;
  }
  
  /**
   * set the year of the Date 
   * @param newYear the new year (in 4 digits)
   */
  public void setYear(int newYear)
  {
  	this.year = newYear;
  }
  
  /**
   * set the month of the Date 
   * @param newMonth the new month (1-12)
   */ 
  public void setMonth(int newMonth)
  {
  	this.month = newMonth;
  }

  /**
   * set the day of the Date 
   * @param newDay the new day (1-31)
   */ 
  public void setDay(int newDay)
  {
  	this.day = newDay;
  }

  /**
   * gets the Date year.
   * @return the year of the Date. 
   */
  public int getYear()
  {
  	return(this.year);
  }
  
  /**
   * gets the Date month.
   * @return the month of the Date. 
   */  
  public int getMonth()
  {
  	return(this.month);
  }
  
  /**
   * gets the Date day.
   * @return the day of the Date. 
   */
  public int getDay()
  {
  	return(this.day);
  }

  /**
   * checks if this date comes before a given date
   * @param date the given date
   * @return true if this date comes before date
   */
  public boolean before(Date date)
  {
    //create a temporary boolean to store resault:
    boolean before = false;
  
    if(this.year<date.year)
      before = true;
    else 
    	if(this.year == date.year)
    	{
       		if(this.month<date.month)
         		before = true;
       		else 
       			if(this.month==date.month)
         			if(this.day<date.day)
            			before = true;
     	}
     return before;
  }

  
  /**
   * clones this date 
   * @return a new Date object, which has same attributes 
   * as current date
   */
  public Date cloneDate()
  {
    return new Date(this.day, this.month, this.year);
  }
  
  /**
   * creats a String that represents this date in the format
   * day/month/year (for example: 26/11/1978)
   * @return a String that represents this Date
   */
  public String toString()
  {
    return this.day +"/" + this.month + "/" + this.year;
  }
}