/**
 * This class simulates a Student,which is a Person, that have grades.
 * 
 * @author Galit Shriki & Ilan Perets
 * @version 10.6.2011
 */
public class Student extends Person
{
	// attributes
  	private int[] testsGrades;   // Tests grades.
  
    
  	// constructors
  	public Student(int id, String name)
  	{
    	super(id,name);
    	testsGrades = new int[0];
  	}
  
  	public Student(Student student) // copy constructor
  	{
    	super(student.id,student.name);
    			
  		int[] temp = new int[student.testsGrades.length];
  		
  		// copy the grades
  		for(int i=0; i<student.testsGrades.length; i++)
  			temp[i] = student.testsGrades[i];
  		testsGrades = temp;
  	}
  	
  	
  	// methods
  	public void addTestGrade(int grade)
  	{
  		int i;
  		int[] temp = new int[testsGrades.length + 1];
  		
  		// copy the old grades
  		for(i=0; i<testsGrades.length; i++)
  			temp[i] = testsGrades[i];
  		
  		// add the new grade
  		temp[i] = grade;
  		
  		testsGrades = temp;
  	}

  	public int[] getTestsGrades()
  	{
  		int i;
  		int[] temp = new int[testsGrades.length];
  	
  		for(i=0; i<testsGrades.length; i++)
  			temp[i] = testsGrades[i];
  	
  		return(temp);
  	}
  
  	public double getAverage() 
  	{  
  		double sum = 0;
  	
  		for(int i=0; i<testsGrades.length; i++)
  			sum += testsGrades[i];
    	return(sum/testsGrades.length);
  	}
 
  	public void printDetails()
  	{
  		int i;
  	
  		System.out.print("Student details:\n id="+id+", name="+name+", Tests=(");
  		for(i=0; i<testsGrades.length-1; i++)
  			System.out.print(testsGrades[i]+", ");
  		if(testsGrades.length > 0)
  			System.out.print(testsGrades[i]);
  		else
  			System.out.print("no grades");
  		System.out.print(")\n");
  	}
} 